// Parameterized parallelepiped meshed with hexahedra

DefineConstant[ Lx = { 2.0, Min 1, Max 20, Step 1, Name "Lx" }  ];// width
DefineConstant[ Ly = { 2.0, Min 1, Max 20, Step 1, Name "Ly" }  ];// depth
DefineConstant[ Lz = { 2.0, Min 1, Max 20, Step 1, Name "Lz" }  ];// height
DefineConstant[ nx = { 2, Min 1, Max 20, Step 1, Name "nx" }  ];// nb of elements along x
DefineConstant[ ny = { 2, Min 1, Max 20, Step 1, Name "ny" }  ];// nb of elements along y
DefineConstant[ nz = { 2, Min 1, Max 20, Step 1, Name "nz" }  ];// nb of elements along z (thickness)
DefineConstant[
  recombine = {1, Choices{0="no",1="yes"},
    Name "recombine"}
];

d=0.05; // not used
Point(1) = {0, 0, 0, d};
Point(2) = {0, Ly, 0, d};
Point(3) = {Lx, Ly, 0, d};
Point(4) = {Lx, 0, 0, d};
Line(1) = {1, 4};
Line(2) = {4, 3};
Line(3) = {2, 3};
Line(4) = {1, 2};
Line Loop(5) = {4, 3, -2, -1};
Plane Surface(6) = {5};
Transfinite Line {4, 2} = ny+1 Using Progression 1;
Transfinite Line {1, 3} = nx+1 Using Progression 1;

If(recombine == 0)
  Extrude {0, 0, Lz} { Surface{6}; Layers{nz}; }
Else
  Transfinite Surface {6} = {1, 4, 3, 2};
  Recombine Surface {6};
  Extrude {0, 0, Lz} { Surface{6}; Layers{nz}; Recombine; }
EndIf

Physical Volume("Volume") = {1};

Physical Surface("Bottom") = {6}; // Z = 0
Physical Surface("Top") = {28};   // Z = Lz
Physical Surface("Front") = {27}; // Y = 0
Physical Surface("Back") = {19};  // Y = Ly
Physical Surface("Left") = {15};  // X = 0
Physical Surface("Right") = {23}; // X = Lx

//+
Physical Point("Corner", 29) = {4};
